/*
 * $RCSfile: hexdump.c,v $
 * 
 * Hex Dump a buffer of binary data
 *
 * Copyright (c) 1996  Arizona Board of Regents
 *
 * $Log: hexdump.c,v $
 * Revision 1.1  1997/04/23 19:15:02  mjk
 * Initial revision
 *
 */

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

void
HexDump(FILE *fout, const char *label, unsigned char *pkt, int len)
{

  int	i, j;

  assert(fout);
  assert(label);
  assert(pkt);
  assert(len >= 0);

	  /* Dumping is in the debug hex/ascii style and is setup for
	     80 columns.  This puts 16 bytes per line with a user
	     provided label. */

  for (i=0; i<len; i+=16) {
    char	buffer[80];
    char	*p = &buffer[0];
    char	*q = &buffer[52];
    
    memset(buffer, (int)' ', sizeof buffer);
    
    for (j=0; j<16 && (j+i) < len; j++) {
      unsigned char	byte = pkt[i+j];

      if ( j == 8 )
	p += sprintf(p, "- ");
      
      p += sprintf(p, "%02x ", byte);
      
      if ( isprint(byte) )
	*q++ = byte;
      else
	*q++ = '.';
    }

    *p = ' ';
    *q = '\0';
    fprintf(fout, "%s: %s\n", label, buffer);
    
  }  
} /* HexDump */
