/*
 * $RCSfile: lcp_fsm_table.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Log: lcp_fsm_table.h,v $
 * Revision 1.1  1994/10/24 20:46:02  andrey
 * Initial revision
 *
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/24 20:46:02 $
 */

/*
 * LCP FSM table - states and actions
 */

/*
 * next state table (events x states)
 *  - note there are no transitions into/out of the error state
 *  - it's just a logging marker
 */
static fsm_next_state lcp_state_table = {
/*up*/   { F_closed, F_req_sent, F_err, F_err, F_err, F_err, F_err, F_err, F_err, F_err, },
/*down*/ { F_err, F_err, F_initial, F_starting, F_initial, F_starting, F_starting, F_starting, F_starting, F_starting },
/*open*/ { F_starting, F_starting, F_req_sent, F_stopped, F_stopping, F_stopping, F_req_sent, F_ack_rcvd, F_ack_sent, F_opened },
/*close*/{ F_initial, F_initial, F_closed, F_closed, F_closing, F_closing, F_closing, F_closing, F_closing, F_closing },

/*t0+*/  { F_err, F_err, F_err, F_err, F_closing, F_stopping, F_req_sent, F_req_sent, F_ack_sent, F_err },
/*t0-*/  { F_err, F_err, F_err, F_err, F_closed, F_stopped, F_stopped, F_stopped, F_stopped, F_err },

/*rcr+*/ { F_err, F_err, F_closed, F_ack_sent, F_closing, F_stopping, F_ack_sent, F_opened, F_ack_sent, F_ack_sent },
/*rcr-*/ { F_err, F_err, F_closed, F_req_sent, F_closing, F_stopping, F_req_sent, F_ack_rcvd, F_req_sent, F_req_sent },
/*rca*/  { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_ack_rcvd, F_req_sent, F_opened, F_req_sent },
/*rcn*/  { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_req_sent, F_req_sent, F_ack_sent, F_req_sent },

/*rtr*/  { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_req_sent, F_req_sent, F_req_sent, F_stopping },
/*rta*/  { F_err, F_err, F_closed, F_stopped, F_closed, F_stopped, F_req_sent, F_req_sent, F_ack_sent, F_req_sent },

/*ruc*/  { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_req_sent, F_ack_rcvd, F_ack_sent, F_opened },
/*rxj+*/ { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_req_sent, F_req_sent, F_ack_sent, F_opened },
/*rxj-*/ { F_err, F_err, F_closed, F_stopped, F_closed, F_stopped, F_stopped, F_stopped, F_stopped, F_closed },
/*rxr*/  { F_err, F_err, F_closed, F_stopped, F_closing, F_stopping, F_req_sent, F_ack_rcvd, F_ack_sent, F_opened },
};

/*
 * action table (events x states)
 */
static fsm_action lcp_fsm_action =
{
/*up*/   { 0, ppp_irc_scr, 0, 0, 0, 0, 0, 0, 0, 0 },
/*down*/ { 0, 0, 0, ppp_tls, 0, 0, 0, 0, 0, ppp_tld },
/*open*/ { ppp_tls, 0, ppp_irc_scr, 0, 0, 0, 0, 0, 0, 0 },
/*close*/{ 0, 0, 0, 0, 0, 0, ppp_irc_str, ppp_irc_str, ppp_irc_str, ppp_tld_irc_str },

/*t0+*/  { 0, 0, 0, 0, ppp_str, ppp_str, ppp_scr, ppp_scr, ppp_scr, 0 },
/*t0-*/  { 0, 0, 0, 0, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, 0 },

/*rcr+*/ { 0, 0, ppp_sta, ppp_irc_scr_sca, 0, 0, ppp_sca, ppp_sca_tlu, ppp_sca, ppp_tld_scr_sca },
/*rcr-*/ { 0, 0, ppp_sta, ppp_irc_scr_scn, 0, 0, ppp_scn, ppp_scn, ppp_scn, ppp_tld_scr_scn },
/*rca*/  { 0, 0, ppp_sta, ppp_sta, 0, 0, ppp_irc, ppp_scr, ppp_irc_tlu, ppp_tld_scr },
/*rcn*/  { 0, 0, ppp_sta, ppp_sta, 0, 0, ppp_irc_scr, ppp_scr, ppp_irc_scr, ppp_tld_scr },

/*rtr*/  { 0, 0, ppp_sta, ppp_sta, ppp_sta, ppp_sta, ppp_sta, ppp_sta, ppp_sta, ppp_tld_zrc_sta },
/*rta*/  { 0, 0, 0, 0, ppp_tlf, ppp_tlf, 0, 0, 0, ppp_tld_scr },

/*ruc*/  { 0, 0, ppp_scj, ppp_scj, ppp_scj, ppp_scj, ppp_scj, ppp_scj, ppp_scj, ppp_scj, },
/*rxj+*/ { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
/*rxj-*/ { 0, 0, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tlf, ppp_tld_irc_str },

/*rxr*/  { 0, 0, 0, 0, 0, 0, 0, 0, 0, ppp_ser },
};

