/* 
 * idea.h
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Arizona Board of Regents
 *
 */

/* #ifndef idea_h */
#define idea_h


#define CRYPT_IN_RESOLVE      (CRYPT_CTL*MAXOPS + 0)
#define CRYPT_IN_SET          (CRYPT_CTL*MAXOPS + 1)
#define CRYPT_IN_INVALIDATE   (CRYPT_CTL*MAXOPS + 2)
#define CRYPT_IN_ISEMPTY      (CRYPT_CTL*MAXOPS + 3)
#define CRYPT_IN_ISVALID      (CRYPT_CTL*MAXOPS + 4)
#define CRYPT_IN_ISINVALID    (CRYPT_CTL*MAXOPS + 5)
#define CRYPT_IN_KEYSIZE      (CRYPT_CTL*MAXOPS + 6)
#define CRYPT_IN_HOSTSIZE     (CRYPT_CTL*MAXOPS + 7)
#define CRYPT_OUT_RESOLVE     (CRYPT_CTL*MAXOPS + 8)
#define CRYPT_OUT_SET         (CRYPT_CTL*MAXOPS + 9)
#define CRYPT_OUT_INVALIDATE  (CRYPT_CTL*MAXOPS + 10)
#define CRYPT_OUT_ISEMPTY     (CRYPT_CTL*MAXOPS + 11)
#define CRYPT_OUT_ISVALID     (CRYPT_CTL*MAXOPS + 12)
#define CRYPT_OUT_ISINVALID   (CRYPT_CTL*MAXOPS + 13)
#define CRYPT_OUT_KEYSIZE     (CRYPT_CTL*MAXOPS + 14)
#define CRYPT_OUT_HOSTSIZE    (CRYPT_CTL*MAXOPS + 15)
#define CRYPT_IVEC_FROM_KEY   (CRYPT_CTL*MAXOPS + 16)
#define CRYPT_ISPRIVATE       (CRYPT_CTL*MAXOPS + 17)
#define CRYPT_READ_FLAGS      (CRYPT_CTL*MAXOPS + 18)
#define CRYPT_SET_FLAGS       (CRYPT_CTL*MAXOPS + 19)
#define CRYPT_CLEAR_FLAGS     (CRYPT_CTL*MAXOPS + 20)
#define CRYPT_READ_IV_DOWN    (CRYPT_CTL*MAXOPS + 21)
#define CRYPT_SET_IV_DOWN     (CRYPT_CTL*MAXOPS + 22)
#define CRYPT_READ_IV_UP      (CRYPT_CTL*MAXOPS + 23)
#define CRYPT_SET_IV_UP       (CRYPT_CTL*MAXOPS + 24)
#define CRYPT_READ_IV_RANDOM  (CRYPT_CTL*MAXOPS + 25)
#define CRYPT_SET_IV_RANDOM   (CRYPT_CTL*MAXOPS + 26)
#define CRYPT_READ_FRAG_DOWN  (CRYPT_CTL*MAXOPS + 27)
#define CRYPT_SET_FRAG_DOWN   (CRYPT_CTL*MAXOPS + 28)
#define CRYPT_READ_FRAG_UP    (CRYPT_CTL*MAXOPS + 29)
#define CRYPT_SET_FRAG_UP     (CRYPT_CTL*MAXOPS + 30)

/* Flags: public names */
#define CRYPT_IP_PSEUDOHDR_HACK  1  /* either protocol or session */
#define CRYPT_IV_FROM_KEY        2  /* protocol or session */
#define CRYPT_ALL_PARTS          4  /* protocol */
#define CRYPT_CBC                8  /* protocol */
#define CRYPT_DECRYPT           16  /* protocol */
#define CRYPT_USE_IPSEC         32  /* protocol */
#define CRYPT_SEND_IV           64  /* protocol or session */
#define CRYPT_SEND_IV_ONCE     128  /* protocol; copied to session */
#define CRYPT_RCV_IV_ONCE      256  /* protocol; copied to session */
#define CRYPT_CRYPT_IV         512  /* protocol or session */
#define CRYPT_ROTATE_BYTE     1024  /* protocol or session */
#define CRYPT_IV_STATE        2048  /* Save IV after encryption/decryption. PorS*/
#define CRYPT_RANDOM_IV       4096  /* protocol or session */
#define CRYPT_IV_FROM_MSG     8192  /* protocol or session */
#define CRYPT_IV_ON_UPMSG    16384  /* protocol or session */
#define CRYPT_FRAGMENTS_DOWN 32768  /* protocol or session */
#define CRYPT_FRAGMENTS_UP   65536  /* protocol or session */
#define CRYPT_NO_PADDING_CHECK 131072  /* protocol */
#define CRYPT_RFC_1829      262144  /* protocol */

#define CRYPT_HEXSTRING     524288  /* protocol */
#define CRYPT_ECB          1048576  /* protocol */
#define CRYPT_CFB          2097152  /* protocol */
#define CRYPT_OFB          4194304  /* protocol */

#ifdef __STDC__
void	idea_init( XObj );
#endif


/* #endif */
