/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: xshepherd.h,v $
 *
 * HISTORY
 * $Log: xshepherd.h,v $
 * Revision 1.2  1994/06/11 00:02:23  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:26:52  davidm
 * Initial revision
 *
 */
/*
 * This module provides the interface between network interrupt
 * handlers and the x-kernel.  When a frame arrives on a network
 * adaptor, the interrupt passes it to a waiting thread or, if
 * no threads are ready, puts it in a queue.
 */
#ifndef xshepherd_h
#define xshepherd_h

#include "upi.h"
#include "xk_config.h"
#include "scout_fifo.h"
#include "scout_lifo.h"

typedef struct xShepherdBuffer {
    struct xShepherdBuffer *next;
    char	hdr[XK_MAX_HARDWARE_HEADER_SIZE];
    Msg		upmsg;
    void	*data;		/* pointer to the data area in "upmsg" */
    struct xobj	*driverProtl;	/* protocol currently using this buffer */
#ifdef XK_SHEPHERD_PROLOG
    void	(*prolog_fun)(struct xShepherdBuffer *buf, void *arg);
    void	*prolog_arg;
#endif /* XK_SHEPHERD_PROLOG */
} XShepherdBuffer;

extern Scout_LIFO	xShepherdThreadCache;
extern Scout_LIFO	xShepherdBufferCache;
extern Scout_FIFO	xShepherdFullBuffers;

extern void	xShepherdInit (void);
extern void	xShepherdMsgDone (Msg *unusedMsg);

#endif /* xshepherd_h */
