/*
 * $RCSfile: hash.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/13 17:43:30 $
 */

/****************************************************************/
/*                                                              */
/* hash.h : header file which prototypes all hash functions     */
/*                                                              */
/****************************************************************/

#ifndef INHASHH
#define INHASHH

typedef struct bucket {
  struct bucket *next;
  struct bucket **prev;
} Bucket;

typedef struct hash_tab_ {
  int size;
  int numsyms;
  unsigned (*hash)();
  int (*cmp)();
  Bucket *table[1];
} Hash_Tab;

extern Hash_Tab *maketab(unsigned maxsym, unsigned (*hash)(), int (*cmp)());
extern void *newsym (int size);
extern void freesym (void *sym);
extern void *addsym (Hash_Tab *tabp, void *sym);
extern void *findsym (Hash_Tab *tabp, void *sym);
extern void *nextsym (Hash_Tab *tabp, void *last);
extern void delsym (Hash_Tab *tabp, void *sym);
extern void cleantab (Hash_Tab *tabp, int (*test)());
extern void nuketab (Hash_Tab *tabp);
extern void *headsym (Hash_Tab *tabp, int n);
extern void *walktab (Hash_Tab *tabp, void *sym);
extern int  ptab (Hash_Tab *tabp, void (*prnt)(), void *par, int srt);

#endif
